% control_lsg3.m
% Aufgabe Kap. 5.6.3
% Verzgerte bertragungsglieder zeitdiskretisiert

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

T  = 0.2 ; V  = 0.8 ;
wn = T/0.005 ; D = 0.05 ;

PT1 = tf (V,[T 1])                  % PT1-Glied
PT2 = tf(V*wn^2,[1 2*D*wn wn^2])    % PT2-Glied
IT1 = tf (1,[1 0])*PT1              % IT1-Glied
DT1 = tf ([1 0],1)*PT1              % DT1-Glied
Tt  = tf (1,1,'IOdelay',0.1)        % Totzeit-Glied

PT1.Notes = 'PT1-Glied' ;
PT2.Notes = 'PT2-Glied' ;
IT1.Notes = 'IT1-Glied' ;
DT1.Notes = 'DT1-Glied' ;
Tt.Notes  = 'Tt-Glied' ;

% Systeme erzeugen
sys2     = [PT1,PT2,IT1,DT1,Tt];
sys2name = [PT1.Notes,PT2.Notes,IT1.Notes,DT1.Notes,Tt.Notes];

% Diskrete Systeme erzeugen
Ts = 0.1 ;
sys2d = c2d([PT1,PT2,IT1,DT1,Tt],Ts);
sys2name = [PT1.Notes,PT2.Notes,IT1.Notes,DT1.Notes,Tt.Notes];

figure
sys2m = max(size(sys2d)) ; 
for m = 1:sys2m, 
    subplot(sys2m,3,3*m-2)
        axis([0 100 0 100])
        text(70,40,[sys2name(m)])
        axis off;
    subplot(sys2m,3,3*m-1)
        if isproper(sys2(m)) , step(sys2(m),sys2d(m),1) , else , axis off; end;
    subplot(sys2m,3,3*m) 
        bode(sys2(m),sys2d(m))
end; % m

if (exist('lpr')~=0)&(lpr==1) , print('-depsc',['lti_modell_verzdiskret.eps']) , end
if (exist('lpr')~=0)&(lpr==1) , print('-deps',['lti_modell_verzdiskret_sw.eps']) , end
%if (exist('lpr')~=0)&(lpr==1) , saveas(gcf,'lti_modell_verzdiskret','fig') , end
