% control_lsg5.m
% Aufgabe Kap. 5.6.5
% Stabilittsanalyse

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. Werte a, b, c variieren

a = [ -1 1 ]; b = [ -1 0 1 ]; c = [ -1 0 1 ]; K = 1 ;

disp(sprintf('  a  |  b  |  c  || Re<0 | Re=0 | Re>0 || konj |'))
disp('------------------------------------------------')
for l = 1:1:length(a)
  for m = 1:1:length(b)
    for n = 1:1:length(c)
      sys = ss([ -b(m)/a(l) -c(n)/a(l) ; 1 0 ],[K/a(l) 0]',[0 1],0) ; 
      p = pole(sys) ;
      disp(sprintf(' %2d  | %2d  | %2d  ||  %2d  |  %2d  |  %2d  ||  %2d  |',...
            a(l),b(m),c(n),sum(real(p<0)),...
            sum(real(p==0)),sum(real(p>0)),sum(imag(p)~=0)/2 ))
    end % m
  end % l
  disp('------------------------------------------------')
end % k

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Polstellenverteilung erzeugen (c variieren)

a = 1 ; b = 1 ; c = [-1:0.05:1] ; K = 1 ;
Pre = [] ; Pim = [] ;

for n=1:1:length(c) 
    sys = ss([ -b/a -c(n)/a ; 1 0 ],[K/a 0]',[0 1],0) ; 
    p = pole(sys) ;
    Pre = [ Pre , real(p) ] ; Pim = [ Pim , imag(p) ] ;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3. Polstellenverteilung plotten

figure
    hold on
    title(['Polstellen (a=',num2str(a),', b=',num2str(b),'; o Anfang, x Ende)'])
    xlabel('Realteil'); ylabel('Imaginrteil')
    text(-1.8,0.8,'Stabil'); text( 0.2,0.8,'INSTABIL')

    plot(Pre(1,:),Pim(1,:),'r-')
    plot(Pre(2,:),Pim(2,:),'b--')
    plot(Pre(1,1),Pim(1,1),'ro',Pre(1,n),Pim(1,n),'rx')
    plot(Pre(2,1),Pim(2,1),'bo',Pre(2,n),Pim(2,n),'bx')
    ax = axis ;
    plot([0 0],[ax(3) ax(4)],'k-')

if (exist('lpr')~=0)&(lpr==1) , print('-depsc',['lti_modell_stabanalyse.eps']) , end
